>let BA' be BA;
>domain Acct strg;
>domain CUST(Acct,InitBal);
>domain TotBal intg;
>domain Amount intg;
>let FromAcct be Acct;
>let ToAcct be Acct;
>domain TOCLOSE(Acct);
>domain Cnt intg;

>domain SUM comp(TotBal);
>domain TRANSFER comp(Amount,FromAcct,ToAcct);
>domain OPENACCT comp(CUST,BA');
>domain CLOSEACCT comp(TOCLOSE);
>domain ACCTCNT comp(Cnt);


>comp BANK(CUST,BA',SUM,TRANSFER,
          OPENACCT,CLOSEACCT,ACCTCNT) is
state customers(Acct,DEPOSIT,BALANCE);
{customers <- [Acct,DEPOSIT,BALANCE] 
                in (CUST ijoin BA');
  
 comp SUM(TotBal) is
 {let CustBal' be BALANCE[];
  let CustBal be [red nop of Bal] in CustBal';
  TotBal <- [red + of CustBal] in customers;
 };

 comp TRANSFER(Amount,FromAcct,ToAcct) is
 {let FBal1 be BALANCE[];
  let FBal2 be [red nop of Bal] in FBal1;
  let FBal be FBal2-Amount;
  FA <- where Acct=FromAcct in customers;
  TA <- where Acct=ToAcct in customers;
  FAS <- where FBal>=0 in FA;
  if (([ ] in FA) and ([ ] in TA)) and ([ ] in FAS) 
  then
  {let nAmount be 0-Amount;
   update customers change DEPOSIT (in nAmount)
    using ijoin where Acct=FromAcct in customers;
   update customers change DEPOSIT(in Amount)
    using ijoin where Acct=ToAcct in customers;
  }
  else
   print "Error in TRANSFER"
 };

 comp OPENACCT(CUST, BA') is
 {new_customers <- [Acct,DEPOSIT,BALANCE] 
                in (CUST ijoin BA');
  update customers add new_customers;
 };

 comp CLOSEACCT(TOCLOSE) is
 {update customers delete TOCLOSE;};

 comp ACCTCNT(Cnt) is
 {Cnt <- [red + of 1] in customers;};
};

>domain corp strg;
>relation BIG5_CUST(corp, CUST) <-
{("BMO",{("S001", 100), 
         ("C002", 20), 
         ("S003", 300)}),
 ("RBC",{("S001", 30000), 
         ("S002", 2000)}),
 ("TD",{("C003", 30)}),
 ("CIBC",{("S001", 30000), 
          ("C002", 100), 
          ("C003", 20000), 
          ("C004", 90)}),
 ("Scotia",{("C001", 40), 
            ("C002", 500), 
            ("S003", 90000)})
};
>pr BIG5_CUST;
+-----------+------+
| corp      | CUST |
+-----------+------+
| BMO       | 1    |
| CIBC      | 4    |
| RBC       | 2    |
| Scotia    | 5    |
| TD        | 3    |
+-----------+------+
relation BIG5_CUST has 5 tuples
>pr .CUST;
+------+------+---------+
| .id  | Acct | InitBal |
+------+------+---------+
| 1    | C002 | 20      |
| 1    | S001 | 100     |
| 1    | S003 | 300     |
| 2    | S001 | 30000   |
| 2    | S002 | 2000    |
| 3    | C003 | 30      |
| 4    | C002 | 100     |
| 4    | C003 | 20000   |
| 4    | C004 | 90      |
| 4    | S001 | 30000   |
| 5    | C001 | 40      |
| 5    | C002 | 500     |
| 5    | S003 | 90000   |
+------+------+---------+
relation .CUST has 13 tuples

>BIG5_BANK <- [corp,CUST,BA'] in BIG5_CUST;
>pr BIG5_BANK;
+---------+-------+------+
| corp    | CUST  | BA'  |
+---------+-------+------+
| BMO     | 1     | 6    |
| CIBC    | 4     | 6    |
| RBC     | 2     | 6    |
| Scotia  | 5     | 6    |
| TD      | 3     | 6    |
+---------+-------+------+
relation BIG5_BANK has 5 tuples
>BIG5 <- 
 [corp,SUM,TRANSFER,OPENACCT,CLOSEACCT,ACCTCNT] 
 in (BIG5_BANK ijoin BANK);
>debug;
Note: debug mode is on
>pr BIG5;
debug ==>Command:OP_COMMAND:OP_PR/OP_SHIFT:null:0
debug ==> Identifier:OP_IDENTIFIER:OP_IDENTIFIER:BIG5:0
+--------+------+----------+----------+-----------+---------+-------------+
| corp   | SUM  | TRANSFER | OPENACCT | CLOSEACCT | ACCTCNT | *customers* |
+--------+------+----------+----------+-----------+---------+-------------+
| BMO    | 10   | 11       | 12       | 13        | 14      | 9           |
| CIBC   | 10   | 11       | 12       | 13        | 14      | 15          |
| RBC    | 10   | 11       | 12       | 13        | 14      | 16          |
| Scotia | 10   | 11       | 12       | 13        | 14      | 17          |
| TD     | 10   | 11       | 12       | 13        | 14      | 18          |
+--------+------+----------+----------+-----------+---------+-------------+
relation BIG5 has 5 tuples

>pr .customers;
debug ==>Command:OP_COMMAND:OP_PR/OP_SHIFT:null:0
debug ==> Identifier:OP_IDENTIFIER:OP_IDENTIFIER:.customers:0
+-----+------+---------+---------+-------------+-------------+
| .id | Acct | DEPOSIT | BALANCE | *bal*       | *oldbal*    |
+-----+------+---------+---------+-------------+-------------+
| 9   | C002 | 7       | 8       | 20          | 0           |
| 9   | S001 | 7       | 8       | 100         | 0           |
| 9   | S003 | 7       | 8       | 300         | 0           |
| 15  | C002 | 7       | 8       | 100         | 0           |
| 15  | C003 | 7       | 8       | 20000       | 0           |
| 15  | C004 | 7       | 8       | 90          | 0           |
| 15  | S001 | 7       | 8       | 30000       | 0           |
| 16  | S001 | 7       | 8       | 30000       | 0           |
| 16  | S002 | 7       | 8       | 2000        | 0           |
| 17  | C001 | 7       | 8       | 40          | 0           |
| 17  | C002 | 7       | 8       | 500         | 0           |
| 17  | S003 | 7       | 8       | 90000       | 0           |
| 18  | C003 | 7       | 8       | 30          | 0           |
+-----+------+---------+---------+-------------+-------------+
relation .customers has 13 tuples

>update BIG5 
 change TRANSFER(in 40,in "C001",in "C002")
 using ijoin where corp="Scotia" in BIG5;
>pr .customers;
debug ==>Command:OP_COMMAND:OP_PR/OP_SHIFT:null:0
debug ==> Identifier:OP_IDENTIFIER:OP_IDENTIFIER:.customers:0
+-----+------+---------+---------+-------------+-------------+
| .id | Acct | DEPOSIT | BALANCE | *bal*       | *oldbal*    |
+-----+------+---------+---------+-------------+-------------+
| ... | ...  | ...     | ...     | ...         | ...         |
| 17  | C001 | 7       | 8       | 0           | 40          |
| 17  | C002 | 7       | 8       | 540         | 500         |
| 17  | S003 | 7       | 8       | 90000       | 0           |
| ... | ...  | ...     | ...     | ...         | ...         |
+-----+------+---------+---------+-------------+-------------+
relation .customers has 13 tuples

>relation NEW_BMO_CUST(Acct,InitBal) <- 
  {("C004", 900), ("S005", 0)};
>update BIG5
 change OPENACCT(in NEW_BMO_CUST,in BA)
 using ijoin where corp="BMO" in BIG5;
>pr .customers;
debug ==>Command:OP_COMMAND:OP_PR/OP_SHIFT:null:0
debug ==> Identifier:OP_IDENTIFIER:OP_IDENTIFIER:.customers:0
+------+------+---------+---------+-------------+-------------+
| .id  | Acct | DEPOSIT | BALANCE | *bal*       | *oldbal*    |
+------+------+---------+---------+-------------+-------------+
| 9    | C002 | 7       | 8       | 20          | 0           |
| 9    | C004 | 7       | 8       | 900         | 0           |
| 9    | S001 | 7       | 8       | 100         | 0           |
| 9    | S003 | 7       | 8       | 300         | 0           |
| 9    | S005 | 7       | 8       | 0           | 0           |
| ...  | ...  | ...     | ...     | ...         | ...         |
+------+------+---------+---------+-------------+-------------+
relation .customers has 15 tuples

>relation CLOSE(Acct) <- 
  {("C004"), ("S001")};
>update BIG5
 change CLOSEACCT(in CLOSE)
 using ijoin where corp="BMO" in BIG5;
>pr .customers;
debug ==>Command:OP_COMMAND:OP_PR/OP_SHIFT:null:0
debug ==> Identifier:OP_IDENTIFIER:OP_IDENTIFIER:.customers:0
+-----+------+---------+---------+-------------+-------------+
| .id | Acct | DEPOSIT | BALANCE | *bal*       | *oldbal*    |
+-----+------+---------+---------+-------------+-------------+
| 9   | C002 | 7       | 8       | 20          | 0           |
| 9   | S003 | 7       | 8       | 300         | 0           |
| 9   | S005 | 7       | 8       | 0           | 0           |
| ... | ...  | ...     | ...     | ...         | ...         |
+-----+------+---------+---------+-------------+-------------+
relation .customers has 13 tuples

>let banksum' be SUM[];
>let banksum be 
  [red nop of TotBal] in banksum';
>Big5Sum <- [corp, banksum] in BIG5;
>pr Big5Sum;
+----------------------+-------------+
| corp                 | banksum     |
+----------------------+-------------+
| BMO                  | 320         |
| CIBC                 | 50190       |
| RBC                  | 32000       |
| Scotia               | 90540       |
| TD                   | 30          |
+----------------------+-------------+
relation Big5Sum has 5 tuples

>let AcctCnt' be ACCTCNT[];
>let AcctCnt be 
  [red nop of Cnt] in AcctCnt';
>Big5Cnt <- [corp, AcctCnt] in BIG5;
>pr Big5Cnt;
+----------------------+-------------+
| corp                 | AcctCnt     |
+----------------------+-------------+
| BMO                  | 3           |
| CIBC                 | 4           |
| RBC                  | 2           |
| Scotia               | 3           |
| TD                   | 1           |
+----------------------+-------------+
relation Big5Cnt has 5 tuples

